// serial.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "main.h"
#include "serialport.h"
#include "XBeePackets.h"
#include <winbase.h>
#include <conio.h>
#include <iostream>
#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// The one and only application object

CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		_tprintf(_T("Fatal Error: MFC initialization failed\n"));
		nRetCode = 1;
	}
	else
	{
		// TODO: code your application's behavior here.

		try {
			CSerialPort COM;	
			COMMTIMEOUTS timeouts;
			DWORD dwErrors;
			PacketHandler packetHandler(COM);
			XBeeInPacket inPacket;
			int COMNum;
			cout<<"Enter COM number:";
			cin>>COMNum;

//Open COM Port
			COM.Open(COMNum, 115200, CSerialPort::NoParity, 8, 
			  CSerialPort::OneStopBit, 
			  CSerialPort::NoFlowControl);

///Timeouts///			
			timeouts.ReadIntervalTimeout = 0; //-1 is no waiting, 0 is infinite waiting
			timeouts.ReadTotalTimeoutMultiplier = 0;
			timeouts.ReadTotalTimeoutConstant = 0;
			timeouts.WriteTotalTimeoutMultiplier = 0;
			timeouts.WriteTotalTimeoutConstant = 0;
			COM.SetTimeouts(timeouts);
///Clear COM Port
			COM.Purge(PURGE_RXCLEAR);
			COM.Flush();
			COM.ClearError(dwErrors);
///

			///main loop
			int returnCode;
			do {
				returnCode = packetHandler.getPacket(inPacket);
				if ((int)inPacket.source != 0 ){
					if (returnCode == 0){
						cout<<"source:"<<inPacket.source<<endl;
						cout<<"data:"<<endl;
						for (int i=0; i<DATA_ARRAY_LENGTH+ADDITIONAL_NUMS; i++){
							switch(i){
								case 0:
								case 2:
									cout<<i<<": "<<inPacket.data[i].dataFloat<<endl;
									break;
								case 4:
									cout<<i<<": "<<inPacket.data[i].dataFloat-(inPacket.data[0].dataFloat * inPacket.data[0].dataFloat)<<endl;
									break;
								case 6:
									cout<<i<<": "<<inPacket.data[i].dataFloat-(inPacket.data[0].dataFloat * inPacket.data[1].dataFloat)<<endl;
									break;
								case 8:
									cout<<i<<": "<<inPacket.data[i].dataFloat-(inPacket.data[1].dataFloat * inPacket.data[1].dataFloat)<<endl;
									break;
								default:
									cout<<i<<":  "<<inPacket.data[i].dataFloat<<endl;
									break;
							}		
						}
					}
					cout<<"Received:"<<endl;
					for (int i=0; i<NUMBER_OF_AGENTS; i++){
						cout<<i<<":"<<packetHandler.getReceivedStats(i)<<endl;
					}
					cout<<"Dropped:"<<packetHandler.getNumDropped()<<endl;
					cout<<"Corrupt:"<<packetHandler.getNumCorrupt()<<endl;
					cout<<"Total:"<<packetHandler.getNumPackets()<<endl<<endl;
					}
			}while(returnCode != -1);


			COM.Flush();
			COM.Close();
			cout<<"press 'q' to exit...";
			while ('q'!= _getch());

		}
		catch (CSerialException* pEx)
		{
			TRACE(_T("Handle Exception, Message:%s\n"), 
							  pEx->GetErrorMessage());
			pEx->Delete();
			cout<<"failure opening serial port"<<endl;
			cin.get();
		}

			}

			return nRetCode;
}
